import greenfoot.*;
public class Player_1 extends Characters
{  
    int speed = 3;
    private int killCount=0;
    public static int hitCount = 0;
    static int mouseX;
    static int mouseY;
    private String keyDown = "";
    public static int sprintBar = 500;
    public static int mineInventory = 1;
    private int mineLoop = 0;

    private final int killsForMine = 7;
    public static int kills = 0;
    public void act() 
    {
        keyControl();
        //mouseControl();
        death();
        shoot();
        death2();
        death1();
        bossDeath();
        setRotation();
        pickUpMine();
        placeMine();
        checkForMineSpawn();
    }    

    private void checkForMineSpawn()
    {
        if(kills >= killsForMine)
        {
            spawnMine();
            kills = 0;
        }
    }

    private void spawnMine()    
    {
        Actor pickupmine;
        pickupmine = new PickupMine();
        int x = Greenfoot.getRandomNumber(1000);
        int y = Greenfoot.getRandomNumber(600);
        getWorld().addObject(pickupmine, x, y);
    }

    private void shoot()
    {
        if(Greenfoot.mouseClicked(null))
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            if(mouse.getButton()==1)
            {
                Greenfoot.playSound("boom_01.wav");
                Actor shell = new Shell();
                getWorld().addObject(shell, getX(), getY());
                shell.setRotation(getRotation());
                Actor bullet2 = new Bullet2();
                turnTowards(mouse.getX(), mouse.getY());
                getWorld().addObject(bullet2, getX(), getY());
                bullet2.turnTowards(mouse.getX(), mouse.getY());
            }
        }
    }

    private void keyControl()
    {  
        //         if(Greenfoot.isKeyDown("shift"))
        //         {
        //             speed = 4;
        //         }
        //         else 
        //         {
        //             speed =3;
        //         }

        //New sprint code by 3dCameron that creates finite sprinting as opposed to infinite.
        if(sprintBar > 0)
        {
            if(Greenfoot.isKeyDown("shift"))
            {
                speed = 4;
                if(sprintBar > 0)
                {
                    sprintBar = sprintBar - 2;
                }
            }
            else
            {
                speed = 3;
                if(sprintBar < 500)
                {
                    sprintBar = sprintBar + 1;
                }
            }
        }
        else
        {
            speed = 3;
            if(Greenfoot.isKeyDown("shift"))
            {
                doNothing();
            }
            else
            {
                sprintBar++;
            }
        }
        if(Greenfoot.isKeyDown("W"))
        {
            setLocation(getX(),getY()-speed);
        }
        if(Greenfoot.isKeyDown("A"))
        {
            setLocation(getX()-speed,getY());
        }
        if(Greenfoot.isKeyDown("S"))
        {
            setLocation(getX(),getY()+speed);
        }
        if(Greenfoot.isKeyDown("D"))
        {
            setLocation(getX()+speed,getY());
        }
    }

    private void death()
    { 
        Actor blindzombie;
        blindzombie = getOneIntersectingObject(ZombieRunner.class);
        if(blindzombie != null)  
        {
            Greenfoot.playSound("player_killed_2.wav");
            getWorld().addObject(new BloodSplatter(), getX(), getY());
            hitCount++;
            if(hitCount >= 5)
            {
                youDied();
                //Quick note- I disabled removing the object on all three deaths, because it causes to many glitches, and the death screen compensates for it. -3dCameron
                //getWorld().removeObject(this);
                return;
            }
        }
    }

    private void death1()
    { 
        Actor zombie_02;
        zombie_02 = getOneIntersectingObject(Zombie_02.class);
        if(zombie_02 != null)  
        {
            Greenfoot.playSound("player_killed_2.wav");
            getWorld().addObject(new BloodSplatter(), getX(), getY());
            hitCount++;
            if(hitCount >= 5)
            {
                ((Level_World_01) getWorld()).isDead = true;
                youDied();
                //getWorld().removeObject(this);
                return;
            }
        }
    }
    private void bossDeath()
    { 
        Actor boss;
        boss = getOneIntersectingObject(Boss1.class);
        if(boss != null)  
        {
            Greenfoot.playSound("player_killed_2.wav");
            getWorld().addObject(new BloodSplatter(), getX(), getY());
            hitCount++;
            boss.move(-30);
            if(hitCount >= 5)
            {
                ((Level_World_01) getWorld()).isDead = true;
                youDied();
                //getWorld().removeObject(this);
                return;
            }
        }
    }

    private void death2()
    { 
        Actor orb;
        orb = getOneIntersectingObject(Orb.class);
        if(orb != null)  
        {
            Greenfoot.playSound("player_killed_2.wav");
            getWorld().addObject(new BloodSplatter(), getX(), getY());
            hitCount++;
            if(hitCount >= 5)
            {
                ((Level_World_01) getWorld()).isDead = true;
                youDied();
                //getWorld().removeObject(this);
                return;
            }
        }
    }

    private void youDied()
    {
        Greenfoot.setWorld( new DeathScreen ());
    }

    private void setRotation()
    {
        if(Greenfoot.mouseMoved(null) || Greenfoot.mouseDragged(null)) {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            mouseX = mouse.getX();//store mouse's X coordinate
            mouseY = mouse.getY();//store mouse's Y corrdinate
        }
        setRotation(pointTo(mouseX,mouseY));//point player at mouse's coordinates
    }

    public int pointTo(int x, int y)
    {
        int dX = x - getX();//get distance between mouse's X and player's X
        int dY = y - getY();//get distance between mouse's Y and player's Y
        double rotation = Math.atan2(dY, dX); 
        rotation = Math.toDegrees(rotation); 
        return (int)rotation;
    }

    private void doNothing()
    {

    }

    private void pickUpMine()
    {   Actor pickupmine;
        pickupmine = getOneIntersectingObject(PickupMine.class);
        if(pickupmine != null)
        {
            mineInventory++; 
            getWorld().removeObject(pickupmine);
        }
    }

    private void placeMine()
    {
        Actor activemine;
        activemine = new ActiveMine();
        if(mineInventory > 0)
        {
            if(Greenfoot.isKeyDown("space"))
            {
                mineLoop++;
                if(mineLoop == 1)
                {
                    getWorld().addObject(activemine, getX(), getY());
                    mineInventory--;
                }
            }
            else
            {
                mineLoop = 0;
            }
        }
    }
    
    private void shellFade()
    {
        //This method is used to fade away spent shells to prevent massive ammounts of lag.
        
    }
}

