import greenfoot.*;  
import java.util.List;
public class Zombie_02 extends Characters
{
    private int i=0;
    private int hitCount=0;

    public void act() 
    {
        respawn();
        respawn1();
        respawn2();
        respawn3();
        respawn4();
        move(2);
        aim();
        animate();
        death();
    }

    public void respawn()
    {
        Actor bullet;
        bullet = getOneIntersectingObject(Bullet.class);
        if(bullet != null)
        {   
            //counter.add(50);
            getWorld().addObject(new Explosion(), getX(), getY());
            
            //Spawn new zombie gib out of the five available.
            createGib();
            
            getWorld().addObject(new RpgGibs(), getX(), getY());
            int a = Greenfoot.getRandomNumber(3);
            if(a == 0)
            {
                setLocation(getWorld().getWidth() +1, Greenfoot.getRandomNumber(640));
                getWorld().removeObject(bullet);
            }
            if(a == 1)
            {
                setLocation( -1, Greenfoot.getRandomNumber(640));
                getWorld().removeObject(bullet);
            }
            if(a == 2)
            {
                setLocation(Greenfoot.getRandomNumber(1150), 0);
                getWorld().removeObject(bullet);
            }
            if(a == 3)
            {
                setLocation(Greenfoot.getRandomNumber(1150), 640);
                getWorld().removeObject(bullet);
            }
            Player_1.kills++;
            ((Level_World_01) getWorld()).addKillCount();
            ((Level_World_01) getWorld()).isDead1 = true;
            return;
        }
    }
        private void createGib()
        {
           //Select a number from zero to four that will be used to select a random zombie gib.
            int zombieGibNum = Greenfoot.getRandomNumber(4);
            //Select a random gib to display on zombie death.
            if(zombieGibNum == 0)
            {
                getWorld().addObject(new zombiegib1(), getX(), getY());
            }
            if(zombieGibNum == 1)
            {
                getWorld().addObject(new zombiegib2(), getX(), getY());
            }
            if(zombieGibNum == 2)
            {
                getWorld().addObject(new zombiegib3(), getX(), getY());
            }
            if(zombieGibNum == 3)
            {
                getWorld().addObject(new zombiegib4(), getX(), getY());
            }
            if(zombieGibNum == 4)
            {
                getWorld().addObject(new zombiegib5(), getX(), getY());
            }
        }
    private void respawn1()
    {
        Actor bullet2;
        bullet2 = getOneIntersectingObject(Bullet2.class);
        if(bullet2 != null)
        {   
            Greenfoot.playSound("hit-boom.wav");
            getWorld().addObject(new BloodSplatter(), getX(), getY());
            hitCount++;
            getWorld().removeObject(bullet2);
            if(hitCount >= 3)
            {
                createGib();
                int a = Greenfoot.getRandomNumber(3);
                if(a == 0)
                {
                    setLocation(getWorld().getWidth() +1, Greenfoot.getRandomNumber(640));
                    getWorld().removeObject(bullet2);
                }
                if(a == 1)
                {
                    setLocation( -1, Greenfoot.getRandomNumber(640));
                    getWorld().removeObject(bullet2);
                }
                if(a == 2)
                {
                    setLocation(Greenfoot.getRandomNumber(1150), 0);
                    getWorld().removeObject(bullet2);
                }
                if(a == 3)
                {
                    setLocation(Greenfoot.getRandomNumber(1150), 640);
                    getWorld().removeObject(bullet2);
                }
                Player_1.kills++;
                ((Level_World_01) getWorld()).addKillCount();
                hitCount=0;
            }
            ((Level_World_01) getWorld()).isDead1 = true;
        }
    }

    private void respawn2()
    {
        Actor explosion;
        explosion = getOneIntersectingObject(Explosion.class);
        if(explosion != null)
        {   
            createGib();
            int a = Greenfoot.getRandomNumber(3);
            if(a == 0)
            {
                setLocation(getWorld().getWidth() +1, Greenfoot.getRandomNumber(640));

            }
            if(a == 1)
            {
                setLocation( -1, Greenfoot.getRandomNumber(640));

            }
            if(a == 2)
            {
                setLocation(Greenfoot.getRandomNumber(1150), 0);
            }
            if(a == 3)
            {
                setLocation(Greenfoot.
                getRandomNumber(1150), 640);
            }
            Player_1.kills++;
            ((Level_World_01) getWorld()).isDead1 = true;
        }
    }

    private void respawn3()
    {
        Actor player_1;
        player_1 = getOneIntersectingObject(Player_1.class);
        if(player_1 != null)
        {   
            Greenfoot.playSound("Ripping.wav");
            hitCount++;
            if(hitCount >= 1)
            {
                int a = Greenfoot.getRandomNumber(3);
                if(a == 0)
                {
                    setLocation(getWorld().getWidth() +1, Greenfoot.getRandomNumber(640));

                }
                if(a == 1)
                {
                    setLocation( -1, Greenfoot.getRandomNumber(640));

                }
                if(a == 2)
                {
                    setLocation(Greenfoot.getRandomNumber(1150), 0);

                }
                if(a == 3)
                {
                    setLocation(Greenfoot.getRandomNumber(1150), 640);

                }
                Player_1.kills++;
                ((Level_World_01) getWorld()).addKillCount();
                hitCount=0;
            }
            ((Level_World_01) getWorld()).isDead1 = true;
        }
    }
    
    public void respawn4()
    {
        Actor activemine;
        activemine = getOneIntersectingObject(ActiveMine.class);
        if(activemine != null)
        {   
            //counter.add(50);
            getWorld().addObject(new Explosion(), getX(), getY());
            
            //Spawn new zombie gib out of the five available.
            createGib();
            
            getWorld().addObject(new RpgGibs(), getX(), getY());
            int a = Greenfoot.getRandomNumber(3);
            if(a == 0)
            {
                setLocation(getWorld().getWidth() +1, Greenfoot.getRandomNumber(640));
                getWorld().removeObject(activemine);
            }
            if(a == 1)
            {
                setLocation( -1, Greenfoot.getRandomNumber(640));
                getWorld().removeObject(activemine);
            }
            if(a == 2)
            {
                setLocation(Greenfoot.getRandomNumber(1150), 0);
                getWorld().removeObject(activemine);
            }
            if(a == 3)
            {
                setLocation(Greenfoot.getRandomNumber(1150), 640);
                getWorld().removeObject(activemine);
            }
            Player_1.kills++;
            ((Level_World_01) getWorld()).addKillCount();
            ((Level_World_01) getWorld()).isDead1 = true;
            return;
        }
    }
    
    private void animate()
    {
        {
            setImage("zombie.png");
        }
    }

    private void aim()
    {
        if ( !((Level_World_01) getWorld()).isDead)
        // if ( ((Level_World_01) getWorld()).getPlayer() != null && ((Level_World_01) getWorld()).isDead == false)
        {
            int x = ((Level_World_01) getWorld()).getPlayer().getX();
            int y = ((Level_World_01) getWorld()).getPlayer().getY();

            {
                turnTowards(x, y);
            }
        }
        if ( ((Level_World_01) getWorld()).isDead)
        {
            int x = (Greenfoot.getRandomNumber(640));
            int y = (Greenfoot.getRandomNumber(640));
            if(Greenfoot.getRandomNumber(50) <= 1)
            {
                turnTowards(x, y);
            }
        }
    }

    private void death()
    { 
        Actor player;
        player = getOneIntersectingObject(Player_1.class);
        if(player != null)  
        {
            Greenfoot.playSound("player_killed_2.wav");
            hitCount++;
            if(hitCount >= 5)
            {
                ((Level_World_01) getWorld()).isDead = true;
                //getWorld().removeObject(player);
                return;
            }
            else
            {
                ((Level_World_01) getWorld()).isDead = false;
            }
        }

    }
}
